# Tree-Based Models
This module implements:

1. [Decision trees](https://en.wikipedia.org/wiki/Decision_tree_learning) for classification and regression via the CART algorithm ([Breiman, Friedman, Olshen, & Stone, 1984](https://www.amazon.com/Classification-Regression-Wadsworth-Statistics-Probability/dp/0412048418)).
2. [Random forests](https://en.wikipedia.org/wiki/Random_forest) for classification and regression (an example of bootstrap
   aggregating) ([Breiman, 2001](https://www.stat.berkeley.edu/~breiman/randomforest2001.pdf)).
3. [Gradient-boosted decision
   trees](https://en.wikipedia.org/wiki/Gradient_boosting) for classification and regression (an
   example of gradient boosted machines) ([Friedman, 1999/2001](https://projecteuclid.org/download/pdf_1/euclid.aos/1013203451)).

## Plots
<p align="center">
   <img src="img/plot.png" height='800' align='center' />
</p>
